import { PivotView } from '../base/pivotview';
import { IAxisSet, IDataSet } from '../../base';
import { DrillThroughDialog } from '../../common/popups/drillthrough-dialog';
/**
 * `DrillThrough` module.
 */
export declare class DrillThrough {
    private parent;
    /**
     * @hidden
     */
    drillThroughDialog: DrillThroughDialog;
    /**
     * Constructor.
     *
     * @param {PivotView} parent - Instance of pivot table.
     * @hidden
     */
    constructor(parent?: PivotView);
    /**
     * It returns the Module name.
     *
     * @returns {string} - string.
     * @hidden
     */
    getModuleName(): string;
    private addInternalEvents;
    private wireEvents;
    private unWireEvents;
    private mouseClickHandler;
    /** @hidden */
    executeDrillThrough(pivotValue: IAxisSet, rowIndex: number, colIndex: number, element?: Element): void;
    private frameData;
    /** @hidden */
    triggerDialog(valueCaption: string, aggType: string, rawData: IDataSet[], pivotValue: IAxisSet, element: Element): void;
    /**
     * To destroy the drillthrough module.
     *
     * @returns  {void}
     * @hidden
     */
    destroy(): void;
}
